# -*- coding: utf-8 -*-
# code generated by Prisma. DO NOT EDIT.
# pyright: reportUnusedImport=false
# fmt: off

# global imports for type checking
from builtins import bool as _bool
from builtins import int as _int
from builtins import float as _float
from builtins import str as _str
import sys
import decimal
import datetime
from typing import (
    TYPE_CHECKING,
    Optional,
    Iterable,
    Iterator,
    Sequence,
    Callable,
    ClassVar,
    NoReturn,
    TypeVar,
    Generic,
    Mapping,
    Tuple,
    Union,
    List,
    Dict,
    Type,
    Any,
    Set,
    overload,
    cast,
)
from typing_extensions import TypedDict, Literal


from typing_extensions import LiteralString
# -- template models.py.jinja --
from pydantic import BaseModel

from . import fields, actions
from ._types import FuncType
from ._builder import serialize_base64
from ._compat import PYDANTIC_V2, ConfigDict

if TYPE_CHECKING:
    from .client import Prisma


_PrismaModelT = TypeVar('_PrismaModelT', bound='_PrismaModel')


class _PrismaModel(BaseModel):
    if PYDANTIC_V2:
        model_config: ClassVar[ConfigDict] = ConfigDict(
            use_enum_values=True,
            arbitrary_types_allowed=True,
            populate_by_name=True,
        )
    elif not TYPE_CHECKING:
        from ._compat import BaseConfig

        class Config(BaseConfig):
            use_enum_values: bool = True
            arbitrary_types_allowed: bool = True
            allow_population_by_field_name: bool = True
            json_encoders: Dict[Any, FuncType] = {
                fields.Base64: serialize_base64,
            }

    # TODO: ensure this is required by subclasses
    __prisma_model__: ClassVar[str]


class BaseFiling(_PrismaModel):
    __prisma_model__: ClassVar[Literal['Filing']] = 'Filing'  # pyright: ignore[reportIncompatibleVariableOverride]

    @classmethod
    def prisma(cls: Type[_PrismaModelT], client: Optional['Prisma'] = None) -> 'actions.FilingActions[_PrismaModelT]':
        from .client import get_client

        return actions.FilingActions[_PrismaModelT](client or get_client(), cls)


class BaseFilingCompany(_PrismaModel):
    __prisma_model__: ClassVar[Literal['FilingCompany']] = 'FilingCompany'  # pyright: ignore[reportIncompatibleVariableOverride]

    @classmethod
    def prisma(cls: Type[_PrismaModelT], client: Optional['Prisma'] = None) -> 'actions.FilingCompanyActions[_PrismaModelT]':
        from .client import get_client

        return actions.FilingCompanyActions[_PrismaModelT](client or get_client(), cls)


class BaseFilingToCompany(_PrismaModel):
    __prisma_model__: ClassVar[Literal['FilingToCompany']] = 'FilingToCompany'  # pyright: ignore[reportIncompatibleVariableOverride]

    @classmethod
    def prisma(cls: Type[_PrismaModelT], client: Optional['Prisma'] = None) -> 'actions.FilingToCompanyActions[_PrismaModelT]':
        from .client import get_client

        return actions.FilingToCompanyActions[_PrismaModelT](client or get_client(), cls)


class BaseDocument(_PrismaModel):
    __prisma_model__: ClassVar[Literal['Document']] = 'Document'  # pyright: ignore[reportIncompatibleVariableOverride]

    @classmethod
    def prisma(cls: Type[_PrismaModelT], client: Optional['Prisma'] = None) -> 'actions.DocumentActions[_PrismaModelT]':
        from .client import get_client

        return actions.DocumentActions[_PrismaModelT](client or get_client(), cls)


class BasePage(_PrismaModel):
    __prisma_model__: ClassVar[Literal['Page']] = 'Page'  # pyright: ignore[reportIncompatibleVariableOverride]

    @classmethod
    def prisma(cls: Type[_PrismaModelT], client: Optional['Prisma'] = None) -> 'actions.PageActions[_PrismaModelT]':
        from .client import get_client

        return actions.PageActions[_PrismaModelT](client or get_client(), cls)


class BaseChunk(_PrismaModel):
    __prisma_model__: ClassVar[Literal['Chunk']] = 'Chunk'  # pyright: ignore[reportIncompatibleVariableOverride]

    @classmethod
    def prisma(cls: Type[_PrismaModelT], client: Optional['Prisma'] = None) -> 'actions.ChunkActions[_PrismaModelT]':
        from .client import get_client

        return actions.ChunkActions[_PrismaModelT](client or get_client(), cls)


class BaseBlock(_PrismaModel):
    __prisma_model__: ClassVar[Literal['Block']] = 'Block'  # pyright: ignore[reportIncompatibleVariableOverride]

    @classmethod
    def prisma(cls: Type[_PrismaModelT], client: Optional['Prisma'] = None) -> 'actions.BlockActions[_PrismaModelT]':
        from .client import get_client

        return actions.BlockActions[_PrismaModelT](client or get_client(), cls)


class BaseTenant(_PrismaModel):
    __prisma_model__: ClassVar[Literal['Tenant']] = 'Tenant'  # pyright: ignore[reportIncompatibleVariableOverride]

    @classmethod
    def prisma(cls: Type[_PrismaModelT], client: Optional['Prisma'] = None) -> 'actions.TenantActions[_PrismaModelT]':
        from .client import get_client

        return actions.TenantActions[_PrismaModelT](client or get_client(), cls)


class BasePlan(_PrismaModel):
    __prisma_model__: ClassVar[Literal['Plan']] = 'Plan'  # pyright: ignore[reportIncompatibleVariableOverride]

    @classmethod
    def prisma(cls: Type[_PrismaModelT], client: Optional['Prisma'] = None) -> 'actions.PlanActions[_PrismaModelT]':
        from .client import get_client

        return actions.PlanActions[_PrismaModelT](client or get_client(), cls)


class BaseUser(_PrismaModel):
    __prisma_model__: ClassVar[Literal['User']] = 'User'  # pyright: ignore[reportIncompatibleVariableOverride]

    @classmethod
    def prisma(cls: Type[_PrismaModelT], client: Optional['Prisma'] = None) -> 'actions.UserActions[_PrismaModelT]':
        from .client import get_client

        return actions.UserActions[_PrismaModelT](client or get_client(), cls)


class BaseMessage(_PrismaModel):
    __prisma_model__: ClassVar[Literal['Message']] = 'Message'  # pyright: ignore[reportIncompatibleVariableOverride]

    @classmethod
    def prisma(cls: Type[_PrismaModelT], client: Optional['Prisma'] = None) -> 'actions.MessageActions[_PrismaModelT]':
        from .client import get_client

        return actions.MessageActions[_PrismaModelT](client or get_client(), cls)


class BaseChat(_PrismaModel):
    __prisma_model__: ClassVar[Literal['Chat']] = 'Chat'  # pyright: ignore[reportIncompatibleVariableOverride]

    @classmethod
    def prisma(cls: Type[_PrismaModelT], client: Optional['Prisma'] = None) -> 'actions.ChatActions[_PrismaModelT]':
        from .client import get_client

        return actions.ChatActions[_PrismaModelT](client or get_client(), cls)


